module Main

import System
import Data.String

readNumber : IO (Maybe Nat)
readNumber = do
  input <- getLine
  if all isDigit (unpack input)
     then pure (Just (stringToNatOrZ input))
     else pure Nothing

guess : (target : Nat) -> (guesses : Nat) -> IO ()
guess target guesses = do
  putStr ("Your guess (#" ++ show guesses ++ "): ")
  Just thisGuess <- readNumber | Nothing => do putStrLn "Not a number. Try again!"
                                               guess target guesses

  if thisGuess > target
    then do
      putStrLn "Too high!"
      guess target (guesses + 1)
    else if thisGuess < target then do
      putStrLn "Too low!"
      guess target (guesses + 1)
    else
      putStrLn "You got it!"

remainder : Integer -> Integer -> Integer
remainder source divBy =
  if source <= divBy
    then source
    else remainder (source - divBy) divBy

main : IO ()
main = do
  now <- time
  guess (fromInteger (remainder now 100)) 0
