import Data.Vect
import System

readVectLen : (len : Nat) -> IO (Vect len String)
readVectLen Z = pure []
readVectLen (S k) = do x <- getLine
                       xs <- readVectLen k
                       pure (x :: xs)

data VectUnknown : Type -> Type where
  MkVect : (len : Nat) -> Vect len a -> VectUnknown a

readVect : IO (VectUnknown String)
readVect = do x <- getLine
              if x == ""
                 then pure (MkVect _ [])
                 else do MkVect _ xs <- readVect
                         pure (MkVect _ (x :: xs))

printVect : Show a => VectUnknown a -> IO ()
printVect (MkVect len xs) = putStrLn (show xs ++ " (length " ++ show len ++ ")")

readVect' : IO (len ** Vect len String)
readVect' = do x <- getLine
               if x == ""
                  then pure (Z ** [])
                  else do (n ** xs) <- readVect'
                          pure ((S n) ** x :: xs)

zipInputs : IO ()
zipInputs = do putStrLn "Enter first vector (blank line to end):"
               (len1 ** vec1) <- readVect'
               putStrLn "Enter second vector (blank line to end):"
               (len2 ** vec2) <- readVect'
               case exactLength len1 vec2 of
                    Nothing => putStrLn "Vectors are of different lengths!"
                    Just vec2' => printLn (zip vec1 vec2')

inputsEq : IO Bool
inputsEq = do (len1 ** vec1) <- readVect'
              (len2 ** vec2) <- readVect'
              case exactLength len1 vec2 of
                Nothing => pure False
                Just vec2' => pure (vec1 == vec2')

readToBlank : IO (List String)
readToBlank = do first <- getLine
                 if first == ""
                    then pure []
                    else do rest <- readToBlank
                            pure (first :: rest)

data Box : Type -> Type where
  MkBox : a -> Box a

-- Dependent pairs let you do heterogeneous lists! (Thanks, Brian Cardiff!)
val : List (a ** List a)
val = [ (Nat ** [ 1 ]), (String ** [ "hey" ]), (Bool ** [ False ]) ]
