import Data.Fin

data Vect : Nat -> Type -> Type where
     Nil : Vect Z a
     (::) : (x : a) -> (xs : Vect k a) -> Vect (S k) a

%name Vect xs, ys, zs

append : Vect n elem -> Vect m elem -> Vect (n + m) elem
append [] ys = ys
append (x :: xs) ys = x :: append xs ys

zip : Vect n a -> Vect n b -> Vect n (a, b)
zip [] [] = []
zip (x :: xs) (y :: ys) = (x, y) :: zip xs ys

index : Fin n -> Vect n a -> a
index FZ (x :: xs) = x
index (FS x) (y :: xs) = index x xs

tryIndex : {n: _} -> Integer -> Vect n a -> Maybe a
tryIndex i xs = case integerToFin i n of
                  Nothing => Nothing
                  (Just fi) => Just (index fi xs)

vectTake : (out : Fin (S n)) -> Vect n a -> Vect (finToNat out) a
vectTake FZ xs = []
vectTake (FS x) (y :: xs) = y :: vectTake x xs

sumEntries : Num a => {n: _} -> (pos : Integer) -> Vect n a -> Vect n a -> Maybe a
sumEntries pos xs ys =
  case integerToFin pos n of
    Nothing => Nothing
    Just i => Just (index i xs + index i ys)
